uwsgi: temp fork for upstream bug #630310

This commit is contained in:
blshkv 2017-09-08 16:56:38 +08:00
parent 5dece8e8c8
commit 3441805981
No known key found for this signature in database
GPG key ID: 273E3E90D1A6294F
8 changed files with 714 additions and 0 deletions

View file

@ -0,0 +1 @@
DIST uwsgi-2.0.15.tar.gz 794926 SHA256 251f0670628ce9b9f4c2b4288a7ea921e2ddb3d5e886b6aa2358273573e6fdcf SHA512 1a2a82cf99d3e6dfe62fa18fd6f04afd1dc727d61287a1c9f47f1448e76a4858dfd59286118c94672c84ff22bcd8444c0c1568ae46993fdbdb9414ad60474bf4 WHIRLPOOL 1708d010af0bb77082e630d945c2d9d31f887125276a92c3a78d11011242374eeb4e3d361a8b4bc593ebae933cc00510b3f64e42a277508addaf6568285b7eae

View file

@ -0,0 +1,22 @@
From 6b332e6f7e6fc3c267a91ce5b5591684575ea271 Mon Sep 17 00:00:00 2001
From: Damjan Georgievski <gdamjan@gmail.com>
Date: Thu, 13 Oct 2016 00:55:35 +0200
Subject: [PATCH] fix issue #1380 - compiling with llvm/freebsd
---
plugins/php/php_plugin.c | 2 +-
1 file changed, 1 insertion(+), 1 deletion(-)
diff --git a/plugins/php/php_plugin.c b/plugins/php/php_plugin.c
index 536ec1a..ef30180 100644
--- a/plugins/php/php_plugin.c
+++ b/plugins/php/php_plugin.c
@@ -232,7 +232,7 @@ static void sapi_uwsgi_register_variables(zval *track_vars_array TSRMLS_DC)
size_t name_len = equal-usl->value;
char *name = estrndup(usl->value, name_len);
char *strval = equal+1;
- zend_register_string_constant(name, name_len, strval, CONST_CS, 0);
+ zend_register_string_constant(name, name_len, strval, CONST_CS, 0 TSRMLS_CC);
}
usl = usl->next;
}

View file

@ -0,0 +1,9 @@
<IfDefine PROXY_UWSGI>
LoadModule proxy_uwsgi_module modules/mod_proxy_uwsgi.so
</IfDefine>
<IfDefine RUWSGI>
LoadModule uwsgi_module modules/mod_Ruwsgi.so
</IfDefine>
<IfDefine UWSGI>
LoadModule uwsgi_module modules/mod_uwsgi.so
</IfDefine>

View file

@ -0,0 +1,30 @@
[uwsgi]
xml = VAR_XML
yaml = VAR_YAML
json = VAR_JSON
ssl = VAR_SSL
pcre = VAR_PCRE
zeromq = VAR_ZMQ
routing = VAR_ROUTING
debug = VAR_DEBUG
unbit = false
malloc_implementation = VAR_MALLOC
extras =
plugins = VAR_PLUGINS
bin_name = uwsgi
append_version =
plugin_dir = VAR_PLUGIN_DIR
plugin_build_dir = VAR_BUILD_DIR
embedded_plugins = VAR_EMBEDDED
as_shared_library = false
locking = auto
event = auto
timer = auto
filemonitor = auto
blacklist =
whitelist =
embed_files =
embed_config =

View file

@ -0,0 +1,68 @@
# Distributed under the terms of the GNU General Public License v2
# YOU SHOULD ONLY MODIFY THIS FILE IF YOU USE THE UWSGI EMPEROR MODE!
# IF YOU WANT TO RUN A SINGLE APP INSTANCE, CREATE A COPY AND MODIFY THAT INSTEAD!
# Path (or name) of UNIX/TCP socket to bind to
# Example : UWSGI_SOCKET=127.0.0.1:1234
UWSGI_SOCKET=
# Enable threads? (1 = yes, 0 = no). The default is 0
#
UWSGI_THREADS=0
# The path to your uWSGI application.
#
UWSGI_PROGRAM=
# The path to your uWSGI xml config file.
#
UWSGI_XML_CONFIG=
# The number of child processes to spawn. The default is 1.
#
UWSGI_PROCESSES=1
# The log file path. If empty, log only errors
#
UWSGI_LOG_FILE=
# If you want to run your application inside a chroot then specify the
# directory here. Leave this blank otherwise.
#
UWSGI_CHROOT=
# If you want to run your application from a specific directiory specify
# it here. Leave this blank otherwise.
#
UWSGI_DIR=
# PIDPATH folder mode (/run/uwsgi_${PROGNAME})
UWSGI_PIDPATH_MODE=0750
# The user to run your application as. If you do not specify these,
# the application will be run as user root.
#
UWSGI_USER=
# The group to run your application as. If you do not specify these,
# the application will be run as group root.
#
UWSGI_GROUP=
# Run the uwsgi emperor which loads vassals dynamically from this PATH
# see http://projects.unbit.it/uwsgi/wiki/Emperor
# The advised Gentoo folder is /etc/uwsgi.d/
UWSGI_EMPEROR_PATH=
# Emperor PIDPATH folder mode (/run/uwsgi)
UWSGI_EMPEROR_PIDPATH_MODE=0770
# The group the emperor should run as. This is different from the UWSGI_GROUP
# as you could want your apps share some sockets with other processes such as
# www servers while preserving your emperor logs from being accessible by them.
UWSGI_EMPEROR_GROUP=
# Additional options you might want to pass to uWSGI
#
UWSGI_EXTRA_OPTIONS=

View file

@ -0,0 +1,145 @@
#!/sbin/openrc-run
# Copyright 1999-2015 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
PROGNAME=${SVCNAME#*.}
UWSGI_EXEC=/usr/bin/uwsgi
if [ "${SVCNAME}" = "uwsgi" ]; then
PIDPATH=/run/uwsgi
else
PIDPATH="/run/uwsgi_${PROGNAME}"
fi
PIDFILE="${PIDPATH}/${PROGNAME}.pid"
extra_started_commands="${opts} reload stats"
depend() {
need net
}
start_emperor() {
local OPTIONS
OPTIONS="--daemonize"
if [ -n "${UWSGI_LOG_FILE}" ]; then
OPTIONS="${OPTIONS} ${UWSGI_LOG_FILE}"
else
OPTIONS="${OPTIONS} /dev/null --disable-logging"
fi
[ -z "${UWSGI_DIR}" ] && UWSGI_DIR="/"
[ -z "${UWSGI_USER}" ] && UWSGI_USER="root"
[ -z "${UWSGI_GROUP}" ] && UWSGI_GROUP="root"
[ -z "${UWSGI_EMPEROR_PIDPATH_MODE}" ] && UWSGI_EMPEROR_PIDPATH_MODE=0770
if [ -n "${UWSGI_EXTRA_OPTIONS}" ]; then
OPTIONS="${OPTIONS} ${UWSGI_EXTRA_OPTIONS}"
fi
ebegin "Starting uWSGI emperor"
checkpath -d -m ${UWSGI_EMPEROR_PIDPATH_MODE} -o "${UWSGI_USER}":"${UWSGI_EMPEROR_GROUP:-${UWSGI_GROUP}}" "${PIDPATH}"
cd "${UWSGI_DIR}" && \
start-stop-daemon --start --user "${UWSGI_USER}" --exec "${UWSGI_EXEC}" \
--group ${UWSGI_EMPEROR_GROUP:-${UWSGI_GROUP}} \
-- --emperor "${UWSGI_EMPEROR_PATH}" ${OPTIONS} --pidfile "${PIDFILE}"
return $?
}
start_app() {
local OPTIONS
OPTIONS="--master --daemonize"
if [ -n "${UWSGI_LOG_FILE}" ]; then
OPTIONS="${OPTIONS} ${UWSGI_LOG_FILE}"
else
OPTIONS="${OPTIONS} /dev/null --disable-logging"
fi
[ -z "${UWSGI_DIR}" ] && UWSGI_DIR="/"
[ -z "${UWSGI_USER}" ] && UWSGI_USER="root"
[ -z "${UWSGI_GROUP}" ] && UWSGI_GROUP="root"
[ -z "${UWSGI_PIDPATH_MODE}" ] && UWSGI_PIDPATH_MODE=0750
if [ -n "${UWSGI_EXTRA_OPTIONS}" ]; then
OPTIONS="${OPTIONS} ${UWSGI_EXTRA_OPTIONS}"
fi
if [ "${UWSGI_THREADS}" = "1" ]; then
OPTIONS="${OPTIONS} --enable-threads"
fi
if [ -n "${UWSGI_SOCKET}" ]; then
OPTIONS="${OPTIONS} --socket ${UWSGI_SOCKET}"
fi
if [ -n "${UWSGI_PROCESSES}" ]; then
OPTIONS="${OPTIONS} --processes ${UWSGI_PROCESSES}"
fi
if [ -n "${UWSGI_CHROOT}" ]; then
OPTIONS="${OPTIONS} --chroot ${UWSGI_CHROOT}"
fi
if [ -n "${UWSGI_PROGRAM}" ]; then
OPTIONS="${OPTIONS} --fileserve-mode ${UWSGI_PROGRAM}"
fi
if [ -n "${UWSGI_XML_CONFIG}" ]; then
OPTIONS="${OPTIONS} --xmlconfig ${UWSGI_XML_CONFIG}"
fi
ebegin "Starting uWSGI application ${PROGNAME}"
checkpath -d -m ${UWSGI_PIDPATH_MODE} -o "${UWSGI_USER}":"${UWSGI_GROUP}" "${PIDPATH}"
cd "${UWSGI_DIR}" && \
start-stop-daemon --start --user "${UWSGI_USER}" --group "${UWSGI_GROUP}" \
--exec "${UWSGI_EXEC}" -- ${OPTIONS} --pidfile "${PIDFILE}"
return $?
}
start() {
if [ -n "${UWSGI_EMPEROR_PATH}" ]; then
start_emperor
eend $?
else
if [ "${SVCNAME}" = "uwsgi" ]; then
eerror "You are not supposed to run this script directly unless you"
eerror "want to run in Emperor mode. In that case please set the UWSGI_EMPEROR_PATH."
eerror "Otherwise create a symlink for the uwsgi application you want to run as well as"
eerror "a copy of the configuration file and modify it appropriately like so..."
eerror
eerror " ln -s uwsgi /etc/init.d/uwsgi.trac"
eerror " cp /etc/conf.d/uwsgi /etc/conf.d/uwsgi.trac"
eerror " nano /etc/conf.d/uwsgi.trac"
eerror
return 1
else
start_app
eend $?
fi
fi
}
stop() {
if [ -n "${UWSGI_EMPEROR_PATH}" ]; then
ebegin "Stopping uWSGI emperor"
else
ebegin "Stopping uWSGI application ${PROGNAME}"
fi
start-stop-daemon --stop --signal QUIT --pidfile "${PIDFILE}"
eend $?
}
reload() {
ebegin "Reloading uWSGI"
start-stop-daemon --signal HUP --pidfile "${PIDFILE}"
eend $?
}
stats() {
ebegin "Logging uWSGI statistics"
start-stop-daemon --signal USR1 --pidfile "${PIDFILE}"
eend $?
}

View file

@ -0,0 +1,23 @@
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
<pkgmetadata>
<maintainer type="person">
<email>ultrabug@gentoo.org</email>
</maintainer>
<use>
<flag name="embedded">Embed plugins instead of building them as real plugins. When disabling this USE flag make sure you specify all used plugins in your uWSGI configuration. Note: Language plugins will always be built as real plugins.</flag>
<flag name="go">Build the gccgo plugin to run Go applications.</flag>
<flag name="jemalloc">Use <pkg>dev-libs/jemalloc</pkg> instead of libc's malloc</flag>
<flag name="json">Support json as a configuration file format.</flag>
<flag name="pypy">Build the pypy plugin to run your code using <pkg>virtual/pypy</pkg>.</flag>
<flag name="python_asyncio">Use the EXPERIMENTAL asyncio (tulip) for python3.4 async request dispatching and as LoopEngine (see http://uwsgi-docs.readthedocs.org/en/latest/asyncio.html).</flag>
<flag name="python_gevent">Use <pkg>dev-python/gevent</pkg> for async request dispatching and as LoopEngine (see http://projects.unbit.it/uwsgi/wiki/Gevent).</flag>
<flag name="routing">Enable routing support</flag>
<flag name="yaml">Support yaml as a configuration file format.</flag>
<flag name="yajl">Use <pkg>dev-libs/yajl</pkg> instead of <pkg>dev-libs/jansson</pkg> for parsing JSON configuration files (if USe=json is set)</flag>
<flag name="zeromq">Enable logging and deployment via ZeroMQ.</flag>
</use>
<upstream>
<remote-id type="github">unbit/uwsgi</remote-id>
</upstream>
</pkgmetadata>

View file

@ -0,0 +1,416 @@
# Copyright 1999-2017 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
EAPI=5
PYTHON_COMPAT=( python2_7 python3_{4,5,6} pypy )
PYTHON_REQ_USE="threads(+)"
RUBY_OPTIONAL="yes"
USE_RUBY="ruby23 ruby24"
PHP_EXT_INI="no"
PHP_EXT_NAME="dummy"
PHP_EXT_OPTIONAL_USE="php"
USE_PHP="php5-6 php7-0" # deps must be registered separately below
MY_P="${P/_/-}"
inherit apache-module eutils flag-o-matic multilib pax-utils php-ext-source-r2 python-r1 ruby-ng versionator
DESCRIPTION="uWSGI server for Python web applications"
HOMEPAGE="http://projects.unbit.it/uwsgi/"
SRC_URI="https://github.com/unbit/uwsgi/archive/${PV}.tar.gz -> ${P}.tar.gz"
LICENSE="GPL-2"
SLOT="0"
KEYWORDS="~amd64 ~x86 ~amd64-linux"
UWSGI_PLUGINS_STD=( ping cache carbon nagios rpc rrdtool
http ugreen signal syslog rsyslog
router_{uwsgi,redirect,basicauth,rewrite,http,cache,static,memcached,redis,hash,expires,metrics}
{core,fast,raw,ssl}router
redislog mongodblog log{file,socket}
spooler cheaper_busyness symcall
transformation_{chunked,gzip,offload,tofile}
zergpool )
UWSGI_PLUGINS_OPT=( alarm_{curl,xmpp} clock_{monotonic,realtime} curl_cron
dumbloop echo emperor_{amqp,pg,zeromq} forkptyrouter
geoip graylog2 legion_cache_fetch ldap log{crypto,pipe} notfound pam
rados router_{access,radius,spnego,xmldir}
sqlite ssi stats_pusher_statsd
systemd_logger transformation_toupper tuntap webdav xattr xslt zabbix )
LANG_SUPPORT_SIMPLE=( cgi mono perl ) # plugins which can be built in the main build process
LANG_SUPPORT_EXTENDED=( go lua php pypy python python_asyncio python_gevent ruby )
# plugins to be ignored (for now):
# cheaper_backlog2: example plugin
# coroae: TODO
# cplusplus: partially example code, needs explicit class
# dummy: no idea
# example: example plugin
# exception_log: example plugin
# *java*: TODO
# v8: TODO
# matheval: TODO
IUSE="apache2 +caps debug +embedded expat jemalloc json libressl +pcre +routing selinux +ssl +xml yajl yaml zeromq"
for plugin in ${UWSGI_PLUGINS_STD[@]}; do IUSE="${IUSE} +uwsgi_plugins_${plugin}"; done
for plugin in ${UWSGI_PLUGINS_OPT[@]}; do IUSE="${IUSE} uwsgi_plugins_${plugin}"; done
IUSE="${IUSE} ${LANG_SUPPORT_SIMPLE[@]} ${LANG_SUPPORT_EXTENDED[@]}"
REQUIRED_USE="|| ( ${LANG_SUPPORT_SIMPLE[@]} ${LANG_SUPPORT_EXTENDED[@]} )
uwsgi_plugins_logcrypto? ( ssl )
uwsgi_plugins_sslrouter? ( ssl )
routing? ( pcre )
uwsgi_plugins_emperor_zeromq? ( zeromq )
uwsgi_plugins_forkptyrouter? ( uwsgi_plugins_corerouter )
uwsgi_plugins_router_xmldir? ( xml !expat )
pypy? ( python_targets_python2_7 )
python? ( ${PYTHON_REQUIRED_USE} )
python_asyncio? ( python_targets_python3_4 python_gevent )
python_gevent? ( python )
expat? ( xml )"
# util-linux is required for libuuid when requesting zeromq support
# Order:
# 1. Unconditional
# 2. General features
# 3. Plugins
# 4. Language/app support
CDEPEND="sys-libs/zlib
caps? ( sys-libs/libcap )
json? ( !yajl? ( dev-libs/jansson )
yajl? ( dev-libs/yajl ) )
pcre? ( dev-libs/libpcre:3 )
ssl? (
!libressl? ( dev-libs/openssl:0 )
libressl? ( dev-libs/libressl )
)
xml? ( !expat? ( dev-libs/libxml2 )
expat? ( dev-libs/expat ) )
yaml? ( dev-libs/libyaml )
zeromq? ( net-libs/zeromq sys-apps/util-linux )
uwsgi_plugins_alarm_curl? ( net-misc/curl )
uwsgi_plugins_alarm_xmpp? ( net-libs/gloox )
uwsgi_plugins_curl_cron? ( net-misc/curl )
uwsgi_plugins_emperor_pg? ( dev-db/postgresql:= )
uwsgi_plugins_geoip? ( dev-libs/geoip )
uwsgi_plugins_ldap? ( net-nds/openldap )
uwsgi_plugins_pam? ( virtual/pam )
uwsgi_plugins_sqlite? ( dev-db/sqlite:3 )
uwsgi_plugins_rados? ( sys-cluster/ceph )
uwsgi_plugins_router_access? ( sys-apps/tcp-wrappers )
uwsgi_plugins_router_spnego? ( virtual/krb5 )
uwsgi_plugins_systemd_logger? ( sys-apps/systemd )
uwsgi_plugins_webdav? ( dev-libs/libxml2 )
uwsgi_plugins_xslt? ( dev-libs/libxslt )
go? ( dev-lang/go:=[gccgo] )
lua? ( dev-lang/lua:= )
mono? ( =dev-lang/mono-4* )
perl? ( dev-lang/perl:= )
php? (
php_targets_php5-6? ( dev-lang/php:5.6[embed] )
php_targets_php7-0? ( dev-lang/php:7.0[embed] )
)
pypy? ( virtual/pypy )
python? ( ${PYTHON_DEPS} )
python_gevent? ( >=dev-python/gevent-1.2.1[${PYTHON_USEDEP}] )
ruby? ( $(ruby_implementations_depend) )"
DEPEND="${CDEPEND}
virtual/pkgconfig"
RDEPEND="${CDEPEND}
selinux? ( sec-policy/selinux-uwsgi )
uwsgi_plugins_rrdtool? ( net-analyzer/rrdtool )"
want_apache2
S="${WORKDIR}/${MY_P}"
APXS2_S="${S}/apache2"
APACHE2_MOD_CONF="42_mod_uwsgi-r2 42_mod_uwsgi"
# FIXME: is this patch still useful?
PATCHES=(
"${FILESDIR}/2.0.14-php-plugin.patch"
)
src_unpack() {
default
}
pkg_setup() {
python_setup
use ruby && ruby-ng_pkg_setup
depend.apache_pkg_setup
}
src_prepare() {
default
sed -i \
-e "s|'-O2', ||" \
-e "s|'-Werror', ||" \
-e "s|uc.get('plugin_dir')|uc.get('plugin_build_dir')|" \
uwsgiconfig.py || die "sed failed"
sed -i \
-e "s|/lib|/$(get_libdir)|" \
plugins/php/uwsgiplugin.py || die "sed failed"
}
src_configure() {
local embedded_plugins=()
local plugins=()
local malloc_impl="libc"
local json="false"
local xml="false"
for p in ${UWSGI_PLUGINS_STD[@]} ${UWSGI_PLUGINS_OPT[@]} ; do
use uwsgi_plugins_${p} && embedded_plugins+=("${p}")
done
for p in ${LANG_SUPPORT_SIMPLE[@]} ; do
use ${p} && plugins+=("${p}")
done
# do not embed any plugins
if ! use embedded; then
plugins=( ${plugins[@]} ${embedded_plugins[@]} )
embedded_plugins=()
fi
# flatten the arrays
plugins=${plugins[@]}
embedded_plugins=${embedded_plugins[@]}
# rename some of the use flags, language plugins are always real plugins
plugins="${plugins/perl/psgi}"
plugins="${plugins/sqlite/sqlite3}"
embedded_plugins="${embedded_plugins/sqlite/sqlite3}"
# override defaults as requested by the user
if use xml; then
use expat && xml="expat" || xml="libxml2"
fi
if use json; then
use yajl && json="yajl" || json="jansson"
fi
use jemalloc && malloc_impl="jemalloc"
# prepare the buildconf for gentoo
cp "${FILESDIR}"/gentoo.buildconf buildconf/gentoo.ini || die
sed -i \
-e "s|VAR_XML|${xml}|" \
-e "s|VAR_YAML|$(usex yaml libyaml true)|" \
-e "s|VAR_JSON|${json}|" \
-e "s|VAR_SSL|$(usex ssl true false)|" \
-e "s|VAR_PCRE|$(usex pcre true false)|" \
-e "s|VAR_ZMQ|$(usex zeromq true false)|" \
-e "s|VAR_ROUTING|$(usex routing true false)|" \
-e "s|VAR_DEBUG|$(usex debug true false)|" \
-e "s|VAR_MALLOC|${malloc_impl}|" \
-e "s|VAR_PLUGINS|${plugins// /, }|" \
-e "s|VAR_PLUGIN_DIR|${EPREFIX}/usr/$(get_libdir)/uwsgi|" \
-e "s|VAR_BUILD_DIR|${T}/plugins|" \
-e "s|VAR_EMBEDDED|${embedded_plugins// /, }|" \
buildconf/gentoo.ini || die "sed failed"
if ! use caps; then
sed -i -e 's|sys/capability.h|DISABLED|' uwsgiconfig.py || die "sed failed"
fi
if ! use zeromq; then
sed -i -e 's|uuid/uuid.h|DISABLED|' uwsgiconfig.py || die "sed failed"
fi
if use uwsgi_plugins_emperor_pg ; then
PGPV="$(best_version dev-db/postgresql)"
PGSLOT="$(get_version_component_range 1-2 ${PGPV##dev-db/postgresql-})"
sed -i \
-e "s|pg_config|pg_config${PGSLOT/.}|" \
plugins/emperor_pg/uwsgiplugin.py || die "sed failed"
fi
}
each_ruby_compile() {
cd "${WORKDIR}/${MY_P}" || die "sed failed"
UWSGICONFIG_RUBYPATH="${RUBY}" python uwsgiconfig.py --plugin plugins/rack gentoo rack_${RUBY##*/} || die "building plugin for ${RUBY} failed"
UWSGICONFIG_RUBYPATH="${RUBY}" python uwsgiconfig.py --plugin plugins/fiber gentoo fiber_${RUBY##*/}|| die "building fiber plugin for ${RUBY} failed"
UWSGICONFIG_RUBYPATH="${RUBY}" python uwsgiconfig.py --plugin plugins/rbthreads gentoo rbthreads_${RUBY##*/}|| die "building rbthreads plugin for ${RUBY} failed"
}
python_compile_plugins() {
local EPYV
local PYV
EPYV=${EPYTHON/.}
PYV=${EPYV/python}
if [[ ${EPYTHON} == pypy* ]]; then
einfo "skipping because pypy is not meant to build plugins on its own"
return
fi
${PYTHON} uwsgiconfig.py --plugin plugins/python gentoo ${EPYV} || die "building plugin for ${EPYTHON} failed"
if use python_asyncio ; then
if [[ "${PYV}" == "34" || "${PYV}" == "35" ]] ; then
${PYTHON} uwsgiconfig.py --plugin plugins/asyncio gentoo asyncio${PYV} || die "building plugin for asyncio-support in ${EPYTHON} failed"
fi
fi
if use python_gevent ; then
${PYTHON} uwsgiconfig.py --plugin plugins/gevent gentoo gevent${PYV} || die "building plugin for gevent-support in ${EPYTHON} failed"
fi
if use pypy ; then
if [[ "${PYV}" == "27" ]] ; then
# TODO: do some proper patching ? The wiki didn't help... I gave up for now.
# QA: RWX --- --- usr/lib64/uwsgi/pypy_plugin.so
append-ldflags -Wl,-z,noexecstack
${PYTHON} uwsgiconfig.py --plugin plugins/pypy gentoo pypy || die "building plugin for pypy-support in ${EPYTHON} failed"
fi
fi
}
python_install_symlinks() {
dosym uwsgi /usr/bin/uwsgi_${EPYTHON/.}
}
src_compile() {
mkdir -p "${T}/plugins" || die
python uwsgiconfig.py --build gentoo || die "building uwsgi failed"
if use go ; then
python uwsgiconfig.py --plugin plugins/gccgo gentoo || die "building plugin for go failed"
fi
if use lua ; then
# setting the name for the pkg-config file to lua, since we don't have
# slotted lua
UWSGICONFIG_LUAPC="lua" python uwsgiconfig.py --plugin plugins/lua gentoo || die "building plugin for lua failed"
fi
if use php ; then
for s in $(php_get_slots); do
UWSGICONFIG_PHPDIR="/usr/$(get_libdir)/${s}" python uwsgiconfig.py --plugin plugins/php gentoo ${s/.} || die "building plugin for ${s} failed"
done
fi
if use python ; then
python_foreach_impl python_compile_plugins
fi
if use ruby ; then
ruby-ng_src_compile
fi
if use apache2 ; then
for m in proxy_uwsgi Ruwsgi uwsgi ; do
APXS2_ARGS="-c mod_${m}.c"
apache-module_src_compile
done
fi
}
src_install() {
dobin uwsgi
pax-mark m "${D}"/usr/bin/uwsgi
insinto /usr/$(get_libdir)/uwsgi
doins "${T}/plugins"/*.so
use cgi && dosym uwsgi /usr/bin/uwsgi_cgi
use go && dosym uwsgi /usr/bin/uwsgi_go
use lua && dosym uwsgi /usr/bin/uwsgi_lua
use mono && dosym uwsgi /usr/bin/uwsgi_mono
use perl && dosym uwsgi /usr/bin/uwsgi_psgi
if use php ; then
for s in $(php_get_slots); do
dosym uwsgi /usr/bin/uwsgi_${s/.}
done
fi
if use python ; then
python_foreach_impl python_install_symlinks
python_foreach_impl python_domodule uwsgidecorators.py
fi
if use apache2; then
for m in proxy_uwsgi Ruwsgi uwsgi ; do
APACHE2_MOD_FILE="${APXS2_S}/.libs/mod_${m}.so"
apache-module_src_install
done
fi
newinitd "${FILESDIR}"/uwsgi.initd-r7 uwsgi
newconfd "${FILESDIR}"/uwsgi.confd-r4 uwsgi
keepdir /etc/"${PN}".d
use uwsgi_plugins_spooler && keepdir /var/spool/"${PN}"
}
pkg_postinst() {
if use apache2 ; then
elog "Three Apache modules have been installed: mod_proxy_uwsgi, mod_uwsgi and mod_Ruwsgi."
elog "You can enable them with -D PROXY_UWSGI, -DUWSGI or -DRUWSGI in /etc/conf.d/apache2."
elog "mod_uwsgi and mod_Ruwsgi have the same configuration interface and define the same symbols."
elog "Therefore you can enable only one of them at a time."
elog "mod_uwsgi is commercially supported by Unbit and stable but a bit hacky."
elog "mod_Ruwsgi is newer and more Apache-API friendly but not commercially supported."
elog "mod_proxy_uwsgi is a proxy module, considered stable and is now the recommended module."
fi
elog "Append the following options to the uwsgi call to load the respective language plugin:"
use cgi && elog " '--plugins cgi' for cgi"
use lua && elog " '--plugins lua' for lua"
use mono && elog " '--plugins mono' for mono"
use perl && elog " '--plugins psgi' for perl"
if use php ; then
for s in $(php_get_slots); do
elog " '--plugins ${s/.}' for ${s}"
done
fi
python_pkg_postinst() {
local EPYV
local PYV
EPYV=${EPYTHON/.}
PYV=${EPYV/python}
if [[ ${EPYTHON} == pypy* ]] ; then
elog " '--plugins pypy' for pypy"
return
fi
elog " "
elog " '--plugins ${EPYV}' for ${EPYTHON}"
if use python_asyncio ; then
if [[ ${EPYV} == python34 ]] ; then
elog " '--plugins ${EPYV},asyncio${PYV}' for asyncio support in ${EPYTHON}"
else
elog " (asyncio is only supported in python3.4)"
fi
fi
if use python_gevent ; then
elog " '--plugins ${EPYV},gevent${PYV}' for gevent support in ${EPYTHON}"
fi
}
use python && python_foreach_impl python_pkg_postinst
#https://bugs.gentoo.org/show_bug.cgi?id=630310
# if use ruby ; then
# for ruby in $USE_RUBY; do
# if use ruby_targets_${ruby} ; then
# elog " '--plugins rack_${ruby/.}' for ${ruby}"
# elog " '--plugins fiber_${ruby/.}' for ${ruby} fibers"
# elog " '--plugins rbthreads_${ruby/.}' for ${ruby} rbthreads"
# fi
# done
# fi
}